/*
 * UosSylph -- E-Mail client library
 * Copyright (C) 2020 ~ 2021 Uniontech Software Technology Co.,Ltd.
 *
 * Author:     shuiqucheng<shuiqucheng@uniontech.com>
 *
 * Maintainer: shuiqucheng<shuiqucheng@uniontech.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef __UOSSYLMAIN_H__
#define __UOSSYLMAIN_H__

#include "libsylph/sylmain.h"

/* SylApp object */

#define UOSSYL_TYPE_APP SYL_TYPE_APP
#define UOSSYL_APP(obj) SYL_APP(obj)
#define UOSSYL_IS_APP(obj) SYL_IS_APP(obj)
#define UOSSYL_APP_CLASS(klass) SYL_APP_CLASS(klass)
#define UOSSYL_IS_APP_CLASS(klass) SYL_IS_APP_CLASS(klass)
#define UOSSYL_APP_GET_CLASS(obj) SYL_APP_GET_CLASS(obj)

typedef SylApp UosSylApp;
typedef SylAppClass UosSylAppClass;

GObject *uos_syl_app_create	(void);
GObject *uos_syl_app_get	(void);

void uos_syl_init		(void);
void uos_syl_init_gettext	(const gchar *package, const gchar *dirname);
gint uos_syl_setup_rc_dir	(void);
void uos_syl_save_all_state	(void);
void uos_syl_cleanup	(void);

#endif /* __UOSSYLMAIN_H__ */
